//
// Vrml.java
//

import java.io.*;

public class Vrml {

    public Vrml(String file, String name) throws IOException {
	outFile = new PrintWriter (new FileWriter (file));
	myName = name;
    }

    public void vrml_path (int n, double p[][])throws IOException{
	int i;
       	outFile.print( "# Draw 2D path\n");
	outFile.print( "#-----------------------------------\n");
	outFile.print( "Transform {\n");
	outFile.print( "\ttranslation 0 0 0");
	outFile.print( "\tchildren Shape {\n");
	outFile.print( "\t\tappearance Appearance {\n");
	outFile.print( "\t\t\tmaterial Material {\n");
	outFile.print( "\t\t\t\tdiffuseColor 0 0 1\n\t\t\t}\n\t\t}\n");
	outFile.print( "\t\tgeometry Extrusion {\n");
	outFile.print( "\t\t\tcrossSection [1 0, 0 -1, -1 0, 0 1, 1 0]\n");
	outFile.print( "\t\t\tscale [");
	outFile.print(DRAW_WIDTH);
	outFile.print(" ");
	outFile.print(DRAW_WIDTH);
	outFile.print("]\n");
	outFile.print( "\t\t\tspine [");
	for (i=0; i<n; i++) {
	    outFile.print( p[i][1]*100);
	    outFile.print(" ");
	    outFile.print( -7.0 );
	    outFile.print(" ");
	    outFile.print(p[i][0]*100);
	    outFile.print(", ");
	}
	outFile.print( "]\n");
	outFile.print( "\t\t}\n\t}\n}\n");

	outFile.print( "# Draw 3D path\n");
	outFile.print( "#-----------------------------------\n");
	outFile.print( "Transform {\n");
	outFile.print( "\ttranslation 0 0 0");
	outFile.print( "\tchildren Shape {\n");
	outFile.print( "\t\tappearance Appearance {\n");
	outFile.print( "\t\t\tmaterial Material {\n");
	outFile.print( "\t\t\t\tdiffuseColor 1 0 0\n\t\t\t}\n\t\t}\n");
	outFile.print( "\t\tgeometry Extrusion {\n");
	outFile.print( "\t\t\tcrossSection [1 0, 0 -1, -1 0, 0 1, 1 0]\n");
	outFile.print( "\t\t\tscale [");
	outFile.print(DRAW_WIDTH);
	outFile.print(" ");
	outFile.print(DRAW_WIDTH);
	outFile.print("]\n");
	outFile.print( "\t\t\tspine [");
	for (i=0; i<n; i++){
	    outFile.print( p[i][1]*100);
	    outFile.print( " " );
	    outFile.print(p[i][2]*3.0);
	    outFile.print( " ");
	    outFile.print( p[i][0]*100);
	    outFile.print(", ");
	}
	outFile.print( "]\n");
	outFile.print( "\t\t}\n\t}\n}\n");
    }

    public void vrml_surface ()throws IOException{
      // Draw in the output vrml file, canvas, background, heading, and surface


        int i, j;

	// Create Header

	outFile.print( "#VRML V2.0 utf8\n");

	outFile.print( "#------------------------------------------------\n");

	outFile.print( "# 24-311: Numerical Methods  Fall'98\n");

	outFile.print( "# ");
	outFile.print(myName);
	outFile.print("\n");

	outFile.print("# 2D Unconstrained Optimization\n");

	outFile.print("#------------------------------------------------\n\n");



	// Set up background

	outFile.print( "# Specify the background color\n");

	outFile.print( "#-----------------------------------\n");

	outFile.print( "Background {\n\tskyColor 1 1 1\n}\n\n"); // White background



	// Create the square for the canvas

	outFile.print( "# Draw the first canvas\n");

	outFile.print( "#-----------------------------------\n");

	outFile.print( "Transform {\n");

	outFile.print( "\trotation 1 0 0 1.5707\n");

	outFile.print( "\ttranslation 10 0 10\n");

	outFile.print( "\tchildren Shape {\n");

	outFile.print( "\t\tappearance Appearance {\n");

	outFile.print( "\t\t\tmaterial Material {\n");

	outFile.print( "\t\t\t\tdiffuseColor 0.9 0.2 0.2\n");

	outFile.print( "\t\t\t\ttransparency 0.5\n\t\t\t}\n\t\t}\n");

	outFile.print( "\t\tgeometry Box {\n");

	outFile.print( "\t\t\tsize 20 20 0.1\n\t\t}\n\t}\n}\n\n");



	// Create the square for the canvas

	outFile.print( "# Draw the second canvas\n");

	outFile.print( "#-----------------------------------\n");

	outFile.print( "Transform {\n");

	outFile.print( "\trotation 1 0 0 1.5707\n");

	outFile.print( "\ttranslation 10 -7.2 10\n");

	outFile.print( "\tchildren Shape {\n");

	outFile.print( "\t\tappearance Appearance {\n");

	outFile.print( "\t\t\tmaterial Material {\n");

	outFile.print( "\t\t\t\tdiffuseColor 0.2 0.2 0.9\n");

	outFile.print( "\t\t\t\ttransparency 0.5\n\t\t\t}\n\t\t}\n");

	outFile.print( "\t\tgeometry Box {\n");

	outFile.print( "\t\t\tsize 20 20 0.1\n\t\t}\n\t}\n}\n\n");



	// Put text heading on the VRML screen

	outFile.print( "# Draw texts\n");

	outFile.print( "#-----------------------------------\n");

	outFile.print( "Transform {\n");

	outFile.print( "\ttranslation 10 18 2\n");

	outFile.print( "\tchildren Shape {\n");

	outFile.print( "\t\tappearance Appearance {\n");

	outFile.print( "\t\t\tmaterial Material {\n");

	outFile.print( "\t\t\t\tdiffuseColor 1 0 0\n");

	outFile.print( "\t\t\t}\n\t\t}\n");

	outFile.print( "\t\tgeometry Text {\n");

	outFile.print( "\t\t\tstring [\"24-311: Numerical Methods--PS7\",\n");

	outFile.print( "\t\t\t\"2D Unconstrained Optimization\",\n");

	outFile.print( "\t\t\t\"");
	outFile.print(myName);
	outFile.print("\"]\n");

	outFile.print( "\t\t\tfontStyle FontStyle {\n");

	outFile.print( "\t\t\t\tfamily \"SANS\"\n");

	outFile.print( "\t\t\t\tjustify \"MIDDLE\"\n");

	outFile.print( "\t\t\t\tstyle \"BOLD\"\n");

	outFile.print( "\t\t\t\tsize 1.5\n\t\t\t}\n\t\t}\n\t}\n}\n\n");



	// Add the x-axis

	outFile.print( "# Define the x axis\n");

	outFile.print( "#-----------------------------------\n");

	outFile.print( "Transform {\n");

	outFile.print( "\ttranslation 0 0 0\n");

	outFile.print( "\tchildren DEF AXIS Shape {\n");

	outFile.print( "\t\tappearance Appearance {\n");

	outFile.print( "\t\t\tmaterial Material {\n");

	outFile.print( "\t\t\t\tdiffuseColor 0.0 0.0 0.0\n\t\t\t}\n\t\t}\n");

	outFile.print( "\t\tgeometry Extrusion {\n");

	outFile.print( "\t\t\tcrossSection [1 0, 0 -1, -1 0, 0 1, 1 0]\n");

	outFile.print( "\t\t\tscale [0.1 0.1, 0.1 0.1, 0.4 0.4, 0 0]\n");

	outFile.print( "\t\t\tspine [0 0 0, 21 0 0, 21 0 0, 22 0 0]\n\t\t}\n\t}\n}\n\n");



	// Add the y-axis

	outFile.print( "# Draw the y axis\n");

	outFile.print( "#-----------------------------------\n");

	outFile.print( "Transform {\n");

	outFile.print( "\trotation 0 0 1 1.5707\n");

	outFile.print( "\tchildren USE AXIS\n}\n\n");



	// Add the z-axis

	outFile.print( "# Draw the z axis\n");

	outFile.print( "#-----------------------------------\n");

	outFile.print( "Transform {\n");

	outFile.print( "\trotation 0 1 0 -1.5707\n");

	outFile.print( "\tchildren USE AXIS\n}\n\n");



	// Draw the surface

	outFile.print( "# Draw the surface\n");

	outFile.print( "#-----------------------------------\n");

	outFile.print( "Transform {\n");

	outFile.print( "\ttranslation 0 0 0\n");

	outFile.print( "\tchildren Shape {\n");

	outFile.print( "\t\tappearance Appearance {\n");

	outFile.print( "\t\t\tmaterial Material {\n");

	outFile.print( "\t\t\t\tdiffuseColor 1.0 1.0 0.0\n");

	outFile.print( "\t\t\t\ttransparency 0.25\n");

	outFile.print( "\t\t\t}\n\t\t}\n");

	outFile.print( "\t\tgeometry ElevationGrid{\n");

	outFile.print( "\t\t\tsolid FALSE\n");

	outFile.print( "\t\t\txDimension ");
	outFile.print(SURF_PREC);
	outFile.print("\n");

	outFile.print( "\t\t\tzDimension ");
	outFile.print( SURF_PREC);
	outFile.print("\n");

	outFile.print( "\t\t\txSpacing ");
	outFile.print(X_SPACING);
	outFile.print("\n");

	outFile.print( "\t\t\tzSpacing " );
	outFile.print(Y_SPACING);
	outFile.print("\n");

	outFile.print( "\t\t\theight [");

	for (i=0; i<SURF_PREC; i++)
 {
	    for (j=0; j<SURF_PREC; j++)
{
		outFile.print( 3.0*Spring.energy(X_SPACING*i/100.0, Y_SPACING*j/100.0));
		outFile.print( ", ");

	    }
	}
	outFile.print( "]\n");

	outFile.print( "\n\t\t}\n\t}\n}\n\n");



    }

    public void VrmlClose() throws IOException {
	outFile.close();
    }

    //class variables
    private PrintWriter outFile;
    private String myName;

    //Constants
    private final double DRAW_WIDTH = 0.2;
    private final int SURF_PREC = 20;
    private final double X_SPACING = 1.0;
    private final double Y_SPACING = 1.0;



}
